<?php
declare(strict_types=1);

namespace Inti\Provider\Query;

/**
 * Interface QueryInterface
 *
 * @package Inti\Provider\Query
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-provider
 */
interface QueryInterface
{
    public function query(): self;
    public function id(int $id): self;
    public function ids(array $ids): self;
    public function limit(int $limit): self;
    public function offset(int $offset): self;
    public function search(string $query): self;
    public function slug(string $slug): self;
    public function slugs(array $slugs): self;
    public function getCount(): int;
    public function getItem(): ?array;
    public function getItems(): array;
}
