<?php
declare(strict_types=1);

namespace Inti\Provider\Type;

/**
 * Class AbstractType
 *
 * @package Inti\Provider\Type
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-provider
 */
abstract class AbstractType implements TypeInterface
{
    protected string $name;

    protected function __construct()
    { }

    public function getName(): string
    {
        return $this->name;
    }

    public static function instance(): TypeInterface
    {
        static $instances = [];

        if (!isset($instances[static::class])){
            $instances[static::class] = new static();
        }

        return $instances[static::class];
    }
}
