<?php
declare(strict_types=1);

namespace IntiTest\Provider\Mock;

use Inti\Provider\Type\AbstractType;
use Inti\Provider\Type\TypeInterface;

/**
 * Class CustomType
 *
 * @package IntiTest\Provider\Mock
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-provider
 */
class CustomType extends AbstractType implements CustomTypeInterface
{
    private static array $instances = [];

    protected string $name;

    protected function __construct(string $name)
    {
        parent::__construct();
        $this->name = $name;
    }

    public static function instance(string $name = 'custom_type'): TypeInterface
    {
        if (!isset(self::$instances[$name])) {
            self::$instances[$name] = new self($name);
        }

        return self::$instances[$name];
    }
}
